﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Stimulsoft.Report.Mvc;
using Stimulsoft.Report;
using System.Data;
using StiReports;
using System.Web.Routing;

namespace MvcViewer__Razor_.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "Welcome to ASP.NET MVC Stimulsoft Demo";
            ViewBag.ToolbarVisible = false;

            return View();
        }

        public ActionResult About()
        {
            return View();
        }


        // --- MvcViewer Actions --- //


        public ActionResult GetReportSnapshot()
        {
            // Create the report object and load data from xml file
            StiReport report = new StiReport();
            DataSet data = new DataSet("Demo");
            data.ReadXml(Server.MapPath("~/Content/Data/Demo.xml"));

            // Restore the route values collection and get the id value
            RouteValueDictionary routeValues = StiMvcViewer.GetRouteValues(this.HttpContext);
            int id = 1;
            if (routeValues["id"] != null) id = Convert.ToInt32(routeValues["id"]);

            // Load report
            switch (id)
            {
                // Load report snapshot
                case 1:
                    //report.Load(Server.MapPath("~/Content/Reports/ErrorTest.mrt"));
                    report.LoadDocument(Server.MapPath("~/Content/Reports/SimpleList.mdc"));
                    break;

                // Load report template
                case 2:
                    report.Load(Server.MapPath("~/Content/Reports/TwoSimpleLists.mrt"));
                    report.RegData(data);
                    break;

                // Load compiled report class
                case 3:
                    report = new StiMasterDetail();
                    report.RegData(data);
                    break;

                // Load compiled report class
                case 4:
                    report = new StiParametersSelectingCountryReport();
                    report.RegData(data);
                    break;
            }

            return StiMvcViewer.GetReportSnapshotResult(HttpContext, report);
        }

        public ActionResult ViewerEvent()
        {
            return StiMvcViewer.ViewerEventResult(HttpContext);
        }

        public ActionResult PrintReport()
        {
            return StiMvcViewer.PrintReportResult(HttpContext);
        }

        public FileResult ExportReport()
        {
            return StiMvcViewer.ExportReportResult(HttpContext);
        }

        public ActionResult Interaction()
        {
            return StiMvcViewer.InteractionResult(HttpContext);
        }
    }
}
